Index: trunk/SophyaLib/TArray/fiospsqmtx.cc
===================================================================
--- trunk/SophyaLib/TArray/fiospsqmtx.cc	(revision 3809)
+++ trunk/SophyaLib/TArray/fiospsqmtx.cc	(revision 3809)
@@ -0,0 +1,204 @@
+//     Persistence manager for template numerical arrays
+//               R. Ansari, C.Magneville   03/2000
+
+#include "pexceptions.h"
+#include "fiondblock.h"
+#include "fiospsqmtx.h"
+#include "datatype.h"
+#include <typeinfo>
+
+
+//----------------------------------------------------------------------
+/*!
+  \class SOPHYA::FIO_SpecialSquareMatrix
+  \ingroup TArray
+
+  \brief Manager class the PPF I/O (SOPHYA persistence) of SpecialSquareMatrix<T> objects.
+ 
+ */
+///////////////////////////////////////////////////////////
+
+namespace SOPHYA {
+
+//! Default constructor
+template <class T>
+FIO_SpecialSquareMatrix<T>::FIO_SpecialSquareMatrix()
+{
+  dobj=NULL;
+  ownobj=false;
+}
+
+
+//! Constructor from the file \b filename - Reads the SpecialSquareMatrix object from the specified file.
+template <class T>
+FIO_SpecialSquareMatrix<T>::FIO_SpecialSquareMatrix(string const & filename) 
+{
+  dobj=NULL;
+  ownobj=false;
+  Read(filename);
+}
+
+//! Constructor from the SpecialSquareMatrix \b obj
+template <class T>
+FIO_SpecialSquareMatrix<T>::FIO_SpecialSquareMatrix(const SpecialSquareMatrix<T> & obj) 
+{ 
+  const SymmetricMatrix<T>* sym = dynamic_cast< const SymmetricMatrix<T> * >(&obj);
+  if (sym != NULL) dobj = new SymmetricMatrix<T>(*sym, true); 
+  else {
+    const LowerTriangularMatrix<T>* trn = dynamic_cast< const LowerTriangularMatrix<T> * >(&obj);
+    if (trn != NULL)  dobj = new LowerTriangularMatrix<T>(*trn, true);
+    else {
+      const DiagonalMatrix<T>* diag = dynamic_cast< const DiagonalMatrix<T> * >(&obj);
+      if (diag != NULL)  dobj = new DiagonalMatrix<T>(*diag, true);
+      else throw TypeMismatchExc("FIO_SpecialSquareMatrix<T>::FIO_SpecialSquareMatrix(obj) Not a TriangularMatrix<T> / DiagonalMatrix<T> / SymmetricMatrix<T> ");
+    }
+  }
+  ownobj=true; 
+}
+
+//! Connect with a SpecialSquareMatrix \b obj
+template <class T>
+FIO_SpecialSquareMatrix<T>::FIO_SpecialSquareMatrix(SpecialSquareMatrix<T> * obj) 
+{ 
+  dobj = obj;
+  ownobj=false; 
+}
+
+//! destructor
+template <class T>
+FIO_SpecialSquareMatrix<T>::~FIO_SpecialSquareMatrix()
+{
+  if (ownobj && dobj) delete dobj;
+}
+
+//! Return the pointer to the connected SpecialSquareMatrix<T> object
+template <class T>
+AnyDataObj* FIO_SpecialSquareMatrix<T>::DataObj()
+{
+  return(dobj);
+}
+
+//! Connect SpecialSquareMatrix \b o
+template <class T>
+void FIO_SpecialSquareMatrix<T>::SetDataObj(AnyDataObj & o)
+{
+  SpecialSquareMatrix<T> * po = dynamic_cast< SpecialSquareMatrix<T> * >(&o);
+  if (po == NULL) {
+    char buff[160];
+    sprintf(buff,"FIO_SpecialSquareMatrix<%s>::SetDataObj(%s) - Object type  error ! ",
+	    DataTypeInfo<T>::getTypeName().c_str(), typeid(o).name());
+    throw TypeMismatchExc(PExcLongMessage(buff));    
+  }
+  if (ownobj && dobj) delete dobj;
+  dobj = po; ownobj = false;
+} 
+
+//! Reads in the SpecialSquareMatrix<T> object from the PPF input stream \b is
+template <class T>
+void FIO_SpecialSquareMatrix<T>::ReadSelf(PInPersist& is)
+{
+// On lit les 4 premiers uint_4
+//  0: Numero de version,  1 : MtxType,  2 != 0 , has Info, 3 : Reserved
+  uint_4 itab[4];
+  is.Get(itab,4);
+
+  if (dobj == NULL)  { 
+    if (itab[1] == (uint_4)C_DiagonalMatrix)  dobj = new DiagonalMatrix<T>;
+    else if (itab[1] == (uint_4)C_LowerTriangularMatrix)  dobj = new LowerTriangularMatrix<T>;
+    else if (itab[1] == (uint_4)C_SymmetricMatrix)  dobj = new SymmetricMatrix<T>;
+    else throw TypeMismatchExc("FIO_SpecialSquareMatrix<T>::ReadSelf() bad matrix type in file");
+  }
+  else {
+    if ((uint_4)dobj->MtxType() != itab[1]) {
+      // cout << " BUG*** dobj->MtxType()=" << (uint_4)(dobj->MtxType()) << " itab[1]=" << itab[1] << endl;
+      throw TypeMismatchExc("FIO_SpecialSquareMatrix<T>::ReadSelf() matrix type dobj <> in file ");
+    }
+  }
+
+// On lit les tailles, etc ...
+
+// Tous les sa_size_t sont ecrit/lu en int_8 afin de maintenir la compatibilite  
+// -- 0: rowSize
+  int_8 tmpi8s[3];
+
+  is.Get(tmpi8s, 3);
+  dobj->SetSize(tmpi8s[0]);
+
+// On lit le datablock
+  is >> dobj->DataBlock();
+// On lit le DVList info si necessaire
+  if (itab[2] != 0)  is >> dobj->Info();  
+}
+
+//! Writes the SpecialSquareMatrix<T> object to the output PPF  stream \b os
+template <class T>
+void FIO_SpecialSquareMatrix<T>::WriteSelf(POutPersist& os) const
+{
+  if (dobj == NULL)   return;
+//  On ecrit 3 uint_4 .... 
+//  0: Numero de version,  1 : reserved  2 != 0 , has Info
+  uint_4 itab[4];
+  itab[0] = 1;  // Numero de version a 1 - fev 2009
+  itab[1] = (uint_4)dobj->MtxType();  // Type de matrice : Diagonal, Triangular, Symmetric ...
+  // cout << " *** DBG** WriteSelf() dobj->MtxType()= " << itab[1] << endl;
+  itab[2] = (dobj->mInfo != NULL) ? 1 : 0;
+  itab[3] = 0;  // Reserved
+  os.Put(itab,4);
+
+// On ecrit les tailles, etc ...
+// Tous les sa_size_t sont ecrit en int_8 afin de pouvoir etre ecrit/relu
+// entre version du programme utilisant int_4 OU int_8 pour sa_size_t 
+  int_8 tmpi8s[3];
+  tmpi8s[0] = dobj->NRows();
+  tmpi8s[1] = tmpi8s[2] = 0;
+  os.Put(tmpi8s, 3);
+  // On ecrit le datablock
+  os << dobj->DataBlock();
+// On ecrit le DVList info si necessaire
+  if (itab[2] != 0)  os << dobj->Info();
+}
+
+} // Fin de namespace SOPHYA 
+
+
+///////////////////////////////////////////////////////////////
+#ifdef __CXX_PRAGMA_TEMPLATES__
+// Instances des delegues FileIO (PPersist)
+#pragma define_template FIO_SpecialSquareMatrix<uint_1>
+#pragma define_template FIO_SpecialSquareMatrix<uint_2>
+#pragma define_template FIO_SpecialSquareMatrix<uint_4>
+#pragma define_template FIO_SpecialSquareMatrix<uint_8>
+#pragma define_template FIO_SpecialSquareMatrix<int_1>
+#pragma define_template FIO_SpecialSquareMatrix<int_2>
+#pragma define_template FIO_SpecialSquareMatrix<int_4>
+#pragma define_template FIO_SpecialSquareMatrix<int_8>
+#pragma define_template FIO_SpecialSquareMatrix<r_4>
+#pragma define_template FIO_SpecialSquareMatrix<r_8>
+#pragma define_template FIO_SpecialSquareMatrix< complex<r_4> >
+#pragma define_template FIO_SpecialSquareMatrix< complex<r_8> >
+#ifdef SO_LDBLE128
+#pragma define_template FIO_SpecialSquareMatrix<r_16>
+#pragma define_template FIO_SpecialSquareMatrix< complex<r_16> >
+#endif
+#endif
+
+#if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
+template class FIO_SpecialSquareMatrix<uint_1>;
+template class FIO_SpecialSquareMatrix<uint_2>;
+template class FIO_SpecialSquareMatrix<uint_4>;
+template class FIO_SpecialSquareMatrix<uint_8>;
+template class FIO_SpecialSquareMatrix<int_1>;
+template class FIO_SpecialSquareMatrix<int_2>;
+template class FIO_SpecialSquareMatrix<int_4>;
+template class FIO_SpecialSquareMatrix<int_8>;
+template class FIO_SpecialSquareMatrix<r_4>;
+template class FIO_SpecialSquareMatrix<r_8>;
+template class FIO_SpecialSquareMatrix< complex<r_4> >;
+template class FIO_SpecialSquareMatrix< complex<r_8> >;
+#ifdef SO_LDBLE128
+template class FIO_SpecialSquareMatrix<r_16>;
+template class FIO_SpecialSquareMatrix< complex<r_16> >;
+#endif
+}
+#endif
Index: trunk/SophyaLib/TArray/fiospsqmtx.h
===================================================================
--- trunk/SophyaLib/TArray/fiospsqmtx.h	(revision 3809)
+++ trunk/SophyaLib/TArray/fiospsqmtx.h	(revision 3809)
@@ -0,0 +1,61 @@
+// This may look like C code, but it is really -*- C++ -*-
+//      template array class for numerical types
+//                     R. Ansari, C.Magneville   03/2000
+//  Ajout gestionnaire PPF pour TriangularMatrix<T>   02/2009
+
+#ifndef FIOSpSqMtx_SEEN
+#define FIOSpSqMtx_SEEN
+
+#include "machdefs.h"
+#include <iostream>
+#include "spesqmtx.h"
+#include "trngmtx.h"
+#include "diagmtx.h"
+#include "symmtx.h"
+#include "ppersist.h"
+
+namespace SOPHYA {
+
+//------------------------------------------------------------------------------------
+
+/////////////////////////////////////////////////////////////////////////
+// Gestionnaire PPF de SpecialSquareMatrix<T>
+
+/*! 
+  \brief Manager class the PPF I/O (SOPHYA persistence) of TriangularMatrix<T> objects.
+ */
+
+template <class T>
+class FIO_SpecialSquareMatrix : public  PPersist  {
+public:
+  FIO_SpecialSquareMatrix();
+  FIO_SpecialSquareMatrix(string const & filename); 
+  FIO_SpecialSquareMatrix(const SpecialSquareMatrix<T> & obj);
+  FIO_SpecialSquareMatrix(SpecialSquareMatrix<T> * obj);
+  virtual ~FIO_SpecialSquareMatrix();
+  virtual AnyDataObj* DataObj();
+  virtual void        SetDataObj(AnyDataObj & o);
+  inline operator SpecialSquareMatrix<T>() { return(*dobj); }
+protected :
+  virtual void ReadSelf(PInPersist&);           
+  virtual void WriteSelf(POutPersist&) const;  
+  SpecialSquareMatrix<T> * dobj; //!< Pointer to the connected SpecialSquareMatrix
+  bool ownobj; //!< true if the connected object belong to the class
+};
+
+/*! \ingroup TArray \fn operator<<(POutPersist&,SpecialSquareMatrix<T>&)
+  \brief Write SpecialSquareMatrix \b obj into POutPersist stream \b os */
+template <class T>
+inline POutPersist& operator << (POutPersist& os, SpecialSquareMatrix<T> & obj)
+{ FIO_SpecialSquareMatrix<T> fio(&obj);  fio.Write(os);  return(os); }
+
+/*! \ingroup TArray \fn operator>>(PInPersist&,SpecialSquareMatrix<T>&)
+  \brief Read SpecialSquareMatrix \b obj from PInPersist stream \b os */
+template <class T>
+inline PInPersist& operator >> (PInPersist& is, SpecialSquareMatrix<T> & obj)
+{ FIO_SpecialSquareMatrix<T> fio(&obj); is.SkipToNextObject(); fio.Read(is); return(is); }
+
+
+} // Fin du namespace
+
+#endif
Index: trunk/SophyaLib/TArray/objlist.list
===================================================================
--- trunk/SophyaLib/TArray/objlist.list	(revision 3791)
+++ trunk/SophyaLib/TArray/objlist.list	(revision 3809)
@@ -1,6 +1,8 @@
 basarr.o
 fioarr.o
+fiospsqmtx.o
 matharr.o
 sopemtx.o
+spesqmtx.o
 tarray.o
 tarrinit.o
Index: trunk/SophyaLib/TArray/smakefile
===================================================================
--- trunk/SophyaLib/TArray/smakefile	(revision 3791)
+++ trunk/SophyaLib/TArray/smakefile	(revision 3809)
@@ -4,8 +4,8 @@
  
 clean:
-	 rm -f $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
+	 rm -f $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)fiospsqmtx.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)spesqmtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
 	rm -f $(SOPHYALIBP)libTArray.a
  
-$(SOPHYALIBP)libTArray.a : $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
+$(SOPHYALIBP)libTArray.a : $(SOPHYAOBJP)basarr.o $(SOPHYAOBJP)fioarr.o $(SOPHYAOBJP)fiospsqmtx.o $(SOPHYAOBJP)matharr.o $(SOPHYAOBJP)sopemtx.o $(SOPHYAOBJP)spesqmtx.o $(SOPHYAOBJP)tarray.o $(SOPHYAOBJP)tarrinit.o $(SOPHYAOBJP)tmatrix.o $(SOPHYAOBJP)tvector.o $(SOPHYAOBJP)utilarr.o
 	$(AR) $(ARFLAGS) $@ $? 
 	touch $(SOPHYAINCP)/SophyaConfInfo/libsophya.objlist
@@ -13,19 +13,25 @@
 $(SOPHYAOBJP)basarr.o: basarr.cc $(SOPHYAINCP)sopnamsp.h \
   $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)machdefs.h basarr.h \
   $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  basarr.cc
  
@@ -33,171 +39,309 @@
   $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
   $(SOPHYAINCP)fiondblock.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)ndatablock.h \
-  $(SOPHYAINCP)anydataobj.h fioarr.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h fioarr.h tarray.h basarr.h \
+  $(SOPHYAINCP)mutyv.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  utilarr.h $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix.h tmatrix_tsnl.h \
+  tvector.h tvector_tsnl.h $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)machdefs.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fioarr.cc
+ 
+$(SOPHYAOBJP)fiospsqmtx.o: fiospsqmtx.cc $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
+  $(SOPHYAINCP)fiondblock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h fiospsqmtx.h spesqmtx.h utilarr.h \
+  $(SOPHYAINCP)mutyv.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix.h tarray.h basarr.h \
+  $(SOPHYAINCP)dvlist.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)mutyv.h tmatrix_tsnl.h trngmtx.h \
+  spesqmtx_tsnl.h diagmtx.h symmtx.h $(SOPHYAINCP)datatype.h \
+  $(SOPHYAINCP)machdefs.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fiospsqmtx.cc
+ 
+$(SOPHYAOBJP)matharr.o: matharr.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h matharr.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  matharr.cc
+ 
+$(SOPHYAOBJP)sopemtx.o: sopemtx.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h sopemtx.h tmatrix.h tarray.h \
+  basarr.h $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix_tsnl.h tvector.h \
+  tvector_tsnl.h $(SOPHYAINCP)smathconst.h \
+  $(SOPHYAINCP)machdefs.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sopemtx.cc
+ 
+$(SOPHYAOBJP)spesqmtx.o: spesqmtx.cc spesqmtx.h $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h utilarr.h \
+  $(SOPHYAINCP)mutyv.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix.h tarray.h basarr.h \
+  $(SOPHYAINCP)dvlist.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)mutyv.h tmatrix_tsnl.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  spesqmtx.cc
+ 
+$(SOPHYAOBJP)tarray.o: tarray.cc $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
+  $(SOPHYAINCP)pexceptions.h \
   $(SOPHYAINCP)machdefs.h tarray.h basarr.h \
   $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h tmatrix.h \
-  tmatrix_tsnl.h tvector.h tvector_tsnl.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)datatype.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  fioarr.cc
- 
-$(SOPHYAOBJP)matharr.o: matharr.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h matharr.h tarray.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarray.cc
+ 
+$(SOPHYAOBJP)tarrinit.o: tarrinit.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h tarrinit.h \
+  $(SOPHYAINCP)sophyainit.h \
+  $(SOPHYAINCP)machdefs.h fioarr.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix.h tmatrix_tsnl.h \
+  tvector.h tvector_tsnl.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarrinit.cc
+ 
+$(SOPHYAOBJP)tmatrix.o: tmatrix.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tmatrix.h tarray.h basarr.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix_tsnl.h
+	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmatrix.cc
+ 
+$(SOPHYAOBJP)tvector.o: tvector.cc $(SOPHYAINCP)sopnamsp.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h tvector.h tmatrix.h tarray.h \
   basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  matharr.cc
- 
-$(SOPHYAOBJP)sopemtx.o: sopemtx.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h sopemtx.h tmatrix.h \
-  tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h tmatrix_tsnl.h \
-  tvector.h tvector_tsnl.h \
-  $(SOPHYAINCP)smathconst.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  sopemtx.cc
- 
-$(SOPHYAOBJP)tarray.o: tarray.cc $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)machdefs.h tarray.h basarr.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarray.cc
- 
-$(SOPHYAOBJP)tarrinit.o: tarrinit.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h tarrinit.h \
-  $(SOPHYAINCP)sophyainit.h \
-  $(SOPHYAINCP)machdefs.h fioarr.h tarray.h \
-  basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h tmatrix.h \
-  tmatrix_tsnl.h tvector.h tvector_tsnl.h \
-  $(SOPHYAINCP)ppersist.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tarrinit.cc
- 
-$(SOPHYAOBJP)tmatrix.o: tmatrix.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)machdefs.h tmatrix.h tarray.h \
-  basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h tmatrix_tsnl.h
-	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tmatrix.cc
- 
-$(SOPHYAOBJP)tvector.o: tvector.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)machdefs.h tvector.h tmatrix.h \
-  tarray.h basarr.h $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)dvlist.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)ndatablock.h utilarr.h \
-  $(SOPHYAINCP)randinterf.h tmatrix_tsnl.h \
-  tvector_tsnl.h
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h $(SOPHYAINCP)dvlist.h \
+  $(SOPHYAINCP)objfio.h $(SOPHYAINCP)mutyv.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h utilarr.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h tmatrix_tsnl.h tvector_tsnl.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  tvector.cc
  
 $(SOPHYAOBJP)utilarr.o: utilarr.cc $(SOPHYAINCP)sopnamsp.h \
-  $(SOPHYAINCP)machdefs.h utilarr.h \
-  $(SOPHYAINCP)mutyv.h \
-  $(SOPHYAINCP)machdefs.h \
-  $(SOPHYAINCP)timestamp.h \
-  $(SOPHYAINCP)objfio.h \
-  $(SOPHYAINCP)anydataobj.h \
-  $(SOPHYAINCP)ppersist.h \
-  $(SOPHYAINCP)pexceptions.h \
-  $(SOPHYAINCP)gnumd5.h \
-  $(SOPHYAINCP)ppfbinstream.h \
-  $(SOPHYAINCP)rawstream.h \
-  $(SOPHYAINCP)ppfnametag.h \
-  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)osx_values.h utilarr.h \
+  $(SOPHYAINCP)mutyv.h $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)timestamp.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)pexceptions.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)gnumd5.h \
+  $(SOPHYAINCP)ppfbinstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)rawstream.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)ppfnametag.h \
+  $(SOPHYAINCP)ppersist.h \
+  $(SOPHYAINCP)randinterf.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)randr48.h \
-  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h $(SOPHYAINCP)objfio.h \
+  $(SOPHYAINCP)ndatablock.h \
+  $(SOPHYAINCP)machdefs.h \
+  $(SOPHYAINCP)anydataobj.h \
   $(SOPHYAINCP)randinterf.h
 	$(CXXCOMPILE) $(CXXTEMPFLG) -o $@  utilarr.cc
